/* 
* AtmAmplifier.cpp
*
* Created: 14/05/2015 01:25:18
* Author: Paul Soulsby
*/


#include "Amplifier.h"

// default constructor
Amplifier::Amplifier()
{
	
} //Amplifier

// default destructor
Amplifier::~Amplifier()
{
} //~AtmAmplifier

void Amplifier::processWavetable(Wavetable& sourceWavetable, char envLevel, char lfoLevel)
{
	unsigned char lfoOffset = ((unsigned int)lfoAmount_+1) * (127 - lfoLevel) >> 8;   //invert lfo here
	unsigned char envOffset = (((unsigned int)envAmount_+1) * abs(envLevel)) >> 7;
	int sample;
	for(unsigned char i=0;i<sourceWavetable.getWaveLength();++i)
	{
		sample = sourceWavetable.getSample(i);
		sample = (int)(255-lfoOffset) * sample >> 8;   //and back again here, otherwise you'll get silence whenever lfo is off
		sample = (int)envOffset * sample >> 8;
		sourceWavetable.setSample(i,(char)sample);
	}	
}
