/* 
* AnalogueControl.cpp
*
* Created: 08/06/2015 22:24:10
* Author: Paul Soulsby
*/


#include "AnalogueControl.h"

// default constructor
AnalogueControl::AnalogueControl(unsigned char initValue)
{
	value_ = initValue;
	valueLast_ = initValue;
} //AnalogueControl

// default destructor
AnalogueControl::~AnalogueControl()
{
} //~AnalogueControl

bool AnalogueControl::hasChanged(unsigned char ticksPassed)
{
	unsigned char a, testval;
	bool changed = false;

	int diff = abs((int)value_ - valueLast_);
	if(diff>kCtrlMoveThreshold && moving_==false)
	{
		moving_ = true;
		moveTick_ = 0;
	}
	else if (moving_==true)
	{
		moveTick_ += ticksPassed;
		if(moveTick_>=kCtrlMoveTimeOut)
		{
			moving_ = false;
		}
	}
	
	if(moving_==true)
	{
		if(value_!=valueLast_)
		{
			valueLast_ = value_;
			changed = true;
		}
	}
	return changed;
}