/* 
* Arpeggiator.h
*
* Created: 27/05/2015 17:17:20
* Author: Paul Soulsby
*/


#ifndef __ARPEGGIATOR_H__
#define __ARPEGGIATOR_H__

#include <stdlib.h>
#include <string.h>
#include "ArpeggiatorProgmem.h"
#include "ArpeggiatorBase.h"

class Arpeggiator
{
//variables
public:
protected:
private:
	ArpeggiatorBase* base_;
	unsigned char type_ = 0;
	unsigned char division_ = 2;
	unsigned int divMult_ = 1;
	unsigned char divBs_ = 4;
	bool pingPong_ = false;
	bool pongDown_ = false;
	char pos_ = 0;
	bool* noteOn_ = NULL;
	unsigned char indexLast_ = arpLength;
	unsigned char noteLast_ = 0;
	unsigned char note_ = 0;
	unsigned char noteOrderUp_[16] = {0};
	unsigned char noteOrderDown_[16] = {0};
//functions
public:
	Arpeggiator(ArpeggiatorBase* base, bool* noteOn);
	~Arpeggiator();
	void setPingPong(bool way){pingPong_ = way;}
	bool getPingPong(){return pingPong_;}
	void setType(unsigned char newType);
	unsigned char getType(){return type_;}
	void setDivision(unsigned char newDiv);
	unsigned char getDivision(){return division_;}
	void refresh(unsigned int cycleTick);
	void buildNoteOrder();
	void reset();
protected:
private:
	Arpeggiator() {}
	Arpeggiator( const Arpeggiator &c );
	Arpeggiator& operator=( const Arpeggiator &c );
	void incrementPos();
	unsigned char getNoteOrder(char shift);
	unsigned char findNote();
}; //Arpeggiator

#endif //__ARPEGGIATOR_H__
