/* 
* Atm.h
*
* Created: 09/06/2015 18:14:47
* Author: Paul Soulsby
*/


#ifndef __ATM_H__
#define __ATM_H__

#include "AtmEngineBase.h"
#include "AtmHardwareBase.h"
#include "AtmEngine.h"
#include "AtmHardware.h"

class Atm : public AtmHardwareBase, AtmEngineBase 
{
//variables
public:
protected:
private:
	AtmHardware& hardware_;
	AtmEngine& engine_;
	const unsigned char IS_FUNC_FILL[2] = {0xFC,0x21};
	const unsigned char IS_SHIFT_HOLD[2] = {0x20,0x81};
	const unsigned char LED_FLASH_TICKS = 1;
	static const unsigned char MIDI_UBRR = 63; //(F_CPU / (MIDI_BAUD*8)) - 1
	unsigned char testNote_ = 60;
//functions
public:
	Atm();
	~Atm();
	void initialize();
	void poll(unsigned char ticksPassed);
	void hardwareSwitchChanged(unsigned char switch_, unsigned char newValue);
	void hardwareSwitchHeld(unsigned char switch_);
	void hardwareAnalogueControlChanged(unsigned char control, unsigned char newValue);
	void hardwareRotaryEncoderChanged(unsigned char rotary, unsigned char newValue, bool clockwise);
	void hardwareMidiReceived(unsigned char data);
	void hardwareMidiError(unsigned char errorType);
	void engineFunctionChanged(unsigned char func, unsigned char val, bool opt);
	void engineBankChanged(unsigned char bank);
	void engineMidiTransmit(unsigned char data);
protected:
private:
	Atm( const Atm &c );
	Atm& operator=( const Atm &c );
	bool isFuncFill(AtmEngine::Func func) const;
	bool isShiftHold(AtmEngine::Func func);
}; //Atm

#endif //__ATM_H__
