/* 
* AtmAudio.h
*
* Created: 04/05/2015 23:34:23
* Author: Paul Soulsby
*/


#ifndef __ATMAUDIO_H__
#define __ATMAUDIO_H__

#include <avr/io.h>
#include <avr/interrupt.h>

#include "Wavetable.h"

#define UPDATE_ON_ZERO 0

#ifndef bitRead
#define bitRead(value, bit) (((value) >> (bit)) & 0x01)
#endif
#ifndef bitSet
#define bitSet(value, bit) ((value) |= (1UL << (bit)))
#endif
#ifndef bitClear
#define bitClear(value, bit) ((value) &= ~(1UL << (bit)))
#endif
#ifndef bitWrite
#define bitWrite(value, bit, bitvalue) (bitvalue ? bitSet(value, bit) : bitClear(value, bit))
#endif

class AtmAudio
{
//variables
public:
protected:
private:
	unsigned long sampleFreq_ = 14080;
//functions
public:
	AtmAudio(unsigned char waveLen);
	~AtmAudio();
	void setSampleFreq(unsigned long newSf);
	unsigned long getSampleFreq(){return sampleFreq_;}
	void pasteWavetable(Wavetable& sourceWavetable);
	void initialize();
protected:
private:
	AtmAudio() {}
	AtmAudio( const AtmAudio &c );
	AtmAudio& operator=( const AtmAudio &c );

}; //AtmAudio

#endif //__ATMAUDIO_H__
