/* 
* SS_Atmegatron_HardwareTester.h
*
* Created: 10/06/2015 10:09:44
* Author: Paul Soulsby
*/


#ifndef __SS_ATMEGATRON_HARDWARETESTER_H__
#define __SS_ATMEGATRON_HARDWARETESTER_H__

#include <SS_Atmegatron_Hardware.h>
#include <SS_Atmegatron_Hardware_Base.h>
#include <SS_Atmegatron_Audio.h>
#include <SS_Wavetable.h>
#include <avr/pgmspace.h>

class SS_Atmegatron_HardwareTester : public SS_Atmegatron_Hardware_Base
{
//variables
public:
	void Tick();
	void Poll(unsigned char ticks_passed);
protected:
private:
	const unsigned char kWavelen = 32;
	const char sine_wave[32] = {-1,23,47,70,89,105,117,124,127,124,117,105,89,70,47,23,-1,-25,-49,-72,-91,-107,-119,-126,-128,-126,-119,-107,-91,-72,-49,-25};
	SS_Atmegatron_Hardware* hardware_ = NULL;
	SS_Atmegatron_Audio* audio_ = NULL;
	unsigned char tick;
	bool circ_ticking[2] = {true,true};
	bool sw_ticking[3] = {true,true,true};
//functions
public:
	SS_Atmegatron_HardwareTester();
	~SS_Atmegatron_HardwareTester();
	void Init();
	void PlaySound(bool way);
	void SwitchChanged(unsigned char sw, unsigned char new_val);
	void SwitchHoldEvent(unsigned char sw);
	void ControlChanged(unsigned char control, unsigned char new_val);
	void RotaryChanged(unsigned char rotary, unsigned char new_val, bool clockwise);
	void MidiRX(unsigned char data);
protected:
private:
	SS_Atmegatron_HardwareTester( const SS_Atmegatron_HardwareTester &c );
	SS_Atmegatron_HardwareTester& operator=( const SS_Atmegatron_HardwareTester &c );

}; //SS_Atmegatron_HardwareTester

#endif //__SS_ATMEGATRON_HARDWARETESTER_H__
