/* 
* AtmOscillator.h
*
* Created: 05/05/2015 17:17:21
* Author: Paul Soulsby
*/


#ifndef __ATMOSCILLATOR_H__
#define __ATMOSCILLATOR_H__

#include <stdlib.h>
#include "Wavetable.h"
#include "AtmOscillatorProgmem.h"


class AtmOscillator
{
//variables
public:
	
protected:
private:
	unsigned char waveLength_;
	unsigned char table_ = 0;
	unsigned char bank_ = 0;
	bool userMode_ = false;
	unsigned int userWaveStartAddress_ = 0;
	Wavetable* userWavetable_ = NULL;
//functions
public:
	AtmOscillator(unsigned char waveLength, unsigned int userWaveStartAddress);
	~AtmOscillator();
	void copyWavetable(Wavetable& destWavetable);
	void setTable(unsigned char newTable);
	unsigned char getTable(){return table_;}
	void setBank(unsigned char newBank){bank_ = newBank;}
	unsigned char getBank(){return bank_;}
	void setUserMode(bool newUserMode);
	bool getUserMode(){return userMode_;}
	unsigned char getWaveLength(){return waveLength_;}
	void setUserWavetableSample(unsigned char index,char newSample);
	char getUserWavetableSample(unsigned char index);
	unsigned int getUserWaveStartAddress(){return userWaveStartAddress_;}
	void writeUserWave(unsigned char waveNum);
	void readUserWave(unsigned char waveNum);
protected:
private:
	AtmOscillator() {}
	AtmOscillator( const AtmOscillator &c );
	AtmOscillator& operator=( const AtmOscillator &c );

}; //AtmOscillator

#endif //__ATMOSCILLATOR_H__
