/*
* AtmPatch.h
*
* Created: 07/05/2015 10:47:14
* Author: Paul Soulsby
*/


#ifndef __ATMPATCH_H__
#define __ATMPATCH_H__

#include <math.h>
#include <stdlib.h>
#include "AtmPatchBase.h"
#include "SsHelpers.h"

#ifndef bitRead
#define bitRead(value, bit) (((value) >> (bit)) & 0x01)
#endif
#ifndef bitSet
#define bitSet(value, bit) ((value) |= (1UL << (bit)))
#endif
#ifndef bitClear
#define bitClear(value, bit) ((value) &= ~(1UL << (bit)))
#endif
#ifndef bitWrite
#define bitWrite(value, bit, bitvalue) (bitvalue ? bitSet(value, bit) : bitClear(value, bit))
#endif
#define HIGH 0x1
#define LOW  0x0

class AtmPatch
{
	//variables
	public:
	static const unsigned char SYSEX_SIZE = 44;
	static const unsigned char PATCH_SIZE = 22;
	protected:
	private:
	unsigned char funcValue_c_[8] = {16,96,0,246,0,8,5,0};
	unsigned char optionValue_c_[2] = {0,0};
	unsigned char ctrlValue_[2][6] = {{255,0,0,0,0,0},{255,0,0,0,0,0}};
	AtmPatchBase* base_ = NULL;
	//functions
	public:
	AtmPatch(AtmPatchBase* base);
	AtmPatch() {}
	~AtmPatch();
	//void initialize();
	void setFunctionValue(unsigned char func, unsigned char newValue);
	unsigned char getFunctionValue(unsigned char func);
	void setOptionValue(unsigned char func, bool newValue);
	bool getOptionValue(unsigned char func);
	void setCtrlValue(unsigned char bank, unsigned char ctrl, unsigned char newValue);
	unsigned char getCtrlValue(unsigned char bank, unsigned char ctrl);
	void setSysexByte(unsigned char index, unsigned char newValue);
	unsigned char getSysexByte(unsigned char index);
	void readPatch(unsigned char patchNum);
	void writePatch(unsigned char patchNum);
	void easterEgg(unsigned int seed);
	protected:
	private:
	AtmPatch( const AtmPatch &c );
	AtmPatch& operator=( const AtmPatch &c );

}; //AtmPatch

#endif //__ATMPATCH_H__
