/* 
* AtmPitch.cpp
*
* Created: 22/05/2015 15:15:06
* Author: Paul Soulsby
*/


#include "AtmPitch.h"

// default constructor
AtmPitch::AtmPitch()
{
} //AtmPitch

// default destructor
AtmPitch::~AtmPitch()
{
} //~AtmPitch

void AtmPitch::setEnvAmount(unsigned char newAmount)
{
	envAmount_ = newAmount;
	envAmountF_ = ((float)envAmount_ * MAX_ENV) / 255;
}

void AtmPitch::setLfoAmount(unsigned char newAmount)
{
	lfoAmount_ = newAmount;
	lfoAmountF_ = ((float)lfoAmount_ * MAX_LFO) / 255;
}

void AtmPitch::refresh(char lfoOutput, char envOutput, char pbendOutput)
{
	unsigned long f;
	f = input_;
	if(lfoAmount_>0)
	{
		f = f * ((unsigned int)shapeExponential(lfoOutput,lfoAmountF_,MULT_LFO) + 1) >> BS_LFO;
	}
	if(envAmount_>0)
	{
		f = f * ((unsigned int)shapeExponential(envOutput,envAmountF_,MULT_ENV) + 1) >> BS_ENV;
	}	
	if(pbendOutput!=0)
	{
		f = f * ((unsigned int)shapeExponential(pbendOutput,MAX_LFO,MULT_LFO) + 1) >> BS_LFO;
	}
	output_ = (unsigned int)f;
}
