/* 
* Flanger.h
*
* Created: 30/05/2015 23:37:47
* Author: Paul Soulsby
*/


#ifndef __FLANGER_H__
#define __FLANGER_H__

#include <stdlib.h>
#include "Wavetable.h"
#include "SsHelpers.h"

class Flanger
{
//variables
public:
protected:
private:
	unsigned char waveLength_;
	unsigned char lfoAmount_ = 0;
	unsigned char envAmount_ = 0;
	unsigned char scale_ = 1;
	unsigned char fbBs_ = 1;
	unsigned char wetBs_ = 1;
	unsigned char dryBs_ = 1;
	Wavetable* wavetable_ = NULL;
	bool cleared_ = false;
//functions
public:
	Flanger(unsigned char waveLength);
	~Flanger();
	void setLfoAmount(unsigned char newValue);
	unsigned char getLfoAmount(){return lfoAmount_;}
	void setEnvAmount(unsigned char newValue);
	unsigned char getEnvAmount(){return envAmount_;}
	void processWavetable(Wavetable& sourceWavetable, char envLevel, char lfoLevel);
	void clearBuffer();
protected:
private:
	Flanger() {}
	Flanger( const Flanger &c );
	Flanger& operator=( const Flanger &c );

}; //Flanger

#endif //__FLANGER_H__
