/* 
* Led.cpp
*
* Created: 08/06/2015 20:41:35
* Author: Paul Soulsby
*/


#include "Led.h"

// default constructor
Led::Led()
{
} //Led

// default destructor
Led::~Led()
{
} //~Led

void Led::setFlashOffTicks(unsigned char offticks)
{
	flashOnOffTicks_c_ = compressFourBit(flashOnOffTicks_c_,offticks,0);
}
unsigned char Led::getFlashOffTicks()
{
	return uncompressFourBit(flashOnOffTicks_c_,0);
}
void Led::setFlashOnTicks(unsigned char onticks)
{
	flashOnOffTicks_c_ = compressFourBit(flashOnOffTicks_c_,onticks,1);
}
unsigned char Led::getFlashOnticks()
{
	return uncompressFourBit(flashOnOffTicks_c_,1);
}
void Led::flash(unsigned char flashes, unsigned char onTicks, unsigned char offTicks, bool startOn)
{
	flashCnt_ = flashes;
	flashTick_ = 0;
	setFlashOnTicks(onTicks);
	setFlashOffTicks(offTicks);
	setState(startOn);
}
void Led::flashStop()
{
	flashCnt_ = 0;
	setState(false);
}
bool Led::refreshFlash(unsigned char tick_inc)
{
	bool flashing = false;
	unsigned char onticks = 0;
	unsigned char offticks = 0;
	if(flashCnt_>0)
	{
		flashing = true;
		flashTick_ += tick_inc;
		onticks = getFlashOnticks();
		offticks = getFlashOffTicks();
		if((led_==true && flashTick_>=onticks) || (led_==false && flashTick_>=offticks))
		{
			if(led_==true)
			{
				flashTick_ -= onticks;
			}
			else
			{
				flashTick_ -= offticks;
			}
			led_ = !led_;
			if(flashCnt_<255)
			{
				flashCnt_--;
			}
		}
	}	
}