/* 
* LedCircular.h
*
* Created: 08/06/2015 19:01:27
* Author: Paul Soulsby
*/


#ifndef __LedCIRCULAR_H__
#define __LedCIRCULAR_H__

#include "SsHelpers.h"

#ifndef bitRead
#define bitRead(value, bit) (((value) >> (bit)) & 0x01)
#endif
#ifndef bitSet
#define bitSet(value, bit) ((value) |= (1UL << (bit)))
#endif
#ifndef bitClear
#define bitClear(value, bit) ((value) &= ~(1UL << (bit)))
#endif
#ifndef bitWrite
#define bitWrite(value, bit, bitvalue) (bitvalue ? bitSet(value, bit) : bitClear(value, bit))
#endif

class LedCircular
{
//variables
public:
protected:
private:
	unsigned int led_c_ = 0;
	unsigned char flashCnt_[16] = {0};
	unsigned char flashOnOffTicks_c_[16] = {0};   //compresses on and off ticks into 4 bit
	unsigned int flashTick_[16] = {0};
//functions
public:
	LedCircular();
	~LedCircular();
	void select(unsigned char value);
	void fill(unsigned char value);
	unsigned int getState(){return led_c_;}
	void setSegment(unsigned char segment, bool led_on);
	void setState(unsigned int leds){led_c_ = leds;}
	void flash(unsigned char segment, unsigned char flashes, unsigned char onTicks, unsigned char offTicks, bool startOn);
	void flashStop(unsigned char segment);
	bool refreshFlash(unsigned char tick_inc);
protected:
private:
	LedCircular( const LedCircular &c );
	LedCircular& operator=( const LedCircular &c );
	bool getSegment(unsigned char segment);
	void setFlashOnTicks(unsigned char segment, unsigned char onticks);
	unsigned char getFlashOnticks(unsigned char segment);
	void setFlashOffTicks(unsigned char segment, unsigned char offticks);
	unsigned char getFlashOffTicks(unsigned char segment);

}; //LedCircular

#endif //__LedCIRCULAR_H__
