/* 
* Ledswitch.h
*
* Created: 08/06/2015 19:56:13
* Author: Paul Soulsby
*/


#ifndef __LedRGB_H__
#define __LedRGB_H__

#include "SsHelpers.h"

class LedRgb
{
//variables
public:
	enum LedRgbColour : unsigned char
	{
		OFF,
		RED,
		GREEN,
		YELLOW,
		BLUE,
		MAGENTA,
		CYAN,
		WHITE
	};
protected:
private:
	LedRgbColour led_ = OFF;
	unsigned char flashOnOff_c_ = 0;
	unsigned char flashCnt_ = 0;
	unsigned char flashOnOffTicks_c_ = 0;  //compresses on and off ticks into 4 bit
	unsigned char flashTick_ = {0};
//functions
public:
	LedRgb();
	~LedRgb();
	void setColour(LedRgbColour colour){led_ = colour;}
	LedRgbColour getColour(){return led_;}
	void flash(unsigned char flashes, unsigned char onTicks, unsigned char offTicks, LedRgbColour on_col, LedRgbColour off_col, bool startOn);
	void flashStop();
	bool refreshFlash(unsigned char tick_inc);
protected:
private:
	LedRgb( const LedRgb &c );
	LedRgb& operator=( const LedRgb &c );
	void setFlashOnTicks(unsigned char onticks);
	unsigned char getFlashOnticks();
	void setFlashOffTicks(unsigned char offticks);
	unsigned char getFlashOffTicks();
	void setFlashOnCol(LedRgbColour oncol);
	LedRgbColour getFlashOnCol();
	void setFlashOffCol(LedRgbColour offcol);
	LedRgbColour getFlashOffCol();
}; //LedRgb

#endif //__LedRGB_H__
