/*
* MasterClock.cpp
*
* Created: 18/05/2015 16:00:24
* Author: Paul Soulsby
*/

#include "MasterClock.h"

// default constructor
MasterClock::MasterClock()
{
} //MasterClock

// default destructor
MasterClock::~MasterClock()
{
} //~MasterClock

void MasterClock::refresh(unsigned char ticksPassed)
{	
	ticks_ += ticksPassed;
	if(ticks_>=ticksPerCycle_)
	{
		ticks_ -= ticksPerCycle_;
	}
	unsigned char bs = bsScaleConstrain(ticks_);
	output_ = (ticks_ << (16-bs)) / (ticksPerCycle_ >> bs);		
}
void MasterClock::setTicksPerCycle(unsigned long ticks)
{
	ticksPerCycle_ = ticks;
	unsigned char bs = bsMultConstrain(ticksPerCycle_);
	ticks_ = (((unsigned long)output_>>bs) * (ticksPerCycle_>>bs)) >> (16-(bs<<1));	
}
void MasterClock::reset()
{
	ticks_ = 0;
	output_ = 0;
}
unsigned char MasterClock::bsMultConstrain(unsigned long ip)
{
	//bs for multiplying with number max 65536. handles anything up to 4194304
	if(ip>1048575)
	{
		return 3;
	}
	else if (ip>262143)
	{
		return 2;
	}
	else if(ip>65535)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}
unsigned char MasterClock::bsScaleConstrain(unsigned long ip)
{
	//for scaling number up.
	if(ip>1048575)
	{
		return 5;
	}
	else if (ip>524287)
	{
		return 4;
	}
	else if(ip>262143)
	{
		return 3;
	}
	else if(ip>131071)
	{
		return 2;
	}
	else if(ip>65535)
	{
		return 1;
	}
	else
	{
		return 4;
	}
}