/*
 * SS_MIDI_Base.h
 *
 * Created: 26/05/2015 17:43:37
 *  Author: Paul Soulsby
 */ 


#ifndef MIDI_BASE_H_
#define MIDI_BASE_H_

class MidiBase
{
	public:
	virtual void midiNoteOnReceived(unsigned char note, unsigned char velocity) = 0;
	virtual void midiNoteOffReceived(unsigned char note) = 0;
	virtual void midiClockStartReceived(void) = 0;
	virtual void midiClockStopReceived(void) = 0;
	virtual void midiSysexStartReceived(void) = 0;
	virtual void midiSysexDataReceived(unsigned char index, unsigned char data) = 0;
	virtual void midiSysexStopReceived(void) = 0;
	virtual void midiSysexWrite(unsigned char data) = 0;
	virtual void midiControlChangeReceived(unsigned char anlControl_, unsigned char val) = 0;
	virtual void midiChannelChanged(unsigned char channel) = 0;
	virtual void midiPitchBendReceived(char bend) = 0;
};

#endif /* MIDI_BASE_H_ */