/* 
* SS_Atmegatron.h
*
* Created: 09/06/2015 18:14:47
* Author: Paul Soulsby
*/


#ifndef __MIN_H__
#define __MIN_H__

#include "MinEngineBase.h"
#include "MinHardwareBase.h"
#include "MinEngine.h"
#include "MinHardware.h"
#include "LedRgb.h"

class Min : public MinHardwareBase, MinEngineBase 
{
//variables
public:
protected:
private:
	MinEngine& engine_;
	MinHardware& hardware_;
	static const unsigned char MIDI_UBRR = 63; //(F_CPU / (MIDI_BAUD*8)) - 1
//functions
public:
	Min();
	~Min();
	void initialize();
	void poll(unsigned char ticksPassed);
	void hardwareSwitchChanged(unsigned char switch_, unsigned char newValue);
	void hardwareSwitchHeld(unsigned char switch_);
	void hardwareAnalogueControlChanged(unsigned char control, unsigned char newValue);
	void hardwareMidiReceived(unsigned char data);
	void hardwareMidiError(unsigned char errorType){}
	void engineValueChanged(unsigned char func, unsigned char val, bool opt);
	void engineBankChanged(unsigned char bank);
	void engineMidiTransmit(unsigned char data);
protected:
private:
	Min( const Min &c );
	Min& operator=( const Min &c );
	void refreshValueLed();
}; //Min

#endif //__MIN_H__
