/*
* Portamento.cpp
*
* Created: 22/05/2015 13:36:36
* Author: Paul Soulsby
*/


#include "Portamento.h"

// default constructor
Portamento::Portamento()
{
	refreshPortaTicks();
} //Portamento

// default destructor
Portamento::~Portamento()
{
} //~Portamento

void Portamento::setInput(unsigned int new_inp)
{
	if(new_inp!=input_ && new_inp!=output_)
	{
		input_ = new_inp;
		lastOutput_ = output_;
		tick_ = 0;
		refreshPortaTicks();		
	}
}
void Portamento::setProportional(bool new_prop)
{
	proportional_ = new_prop;
	refreshPortaTicks();
}

void Portamento::setSpeed(unsigned int new_speed)
{
	speed_ = new_speed;
	refreshPortaTicks();
}

void Portamento::refreshPortaTicks()
{
	unsigned long p;
	if (speed_==0)
	{
		portaTicks_ = 0;
	}
	else if (proportional_==true)
	{
		if (input_>lastOutput_)
		{
			p = (unsigned long)(input_-output_) * speed_ / output_;
		}
		else
		{
			p = (unsigned long)(output_-input_) * speed_ / input_;
		}
		portaTicks_ = (unsigned int)p;
	}
	else
	{
		portaTicks_ = speed_;
	}	
}
void Portamento::refresh(unsigned char ticksPassed)
{

	if (output_!=input_)
	{
		if (portaTicks_==0)
		{
			output_ = input_;
		}
		else
		{
			tick_ += ticksPassed;
			if (tick_>portaTicks_)
			{
				output_ = input_;
			}
			else
			{
				output_ = ((tick_ * ((long)input_ - (long)lastOutput_)) / portaTicks_) + lastOutput_;
			}
		}
	}
	else if (lastOutput_!=output_)
	{
		lastOutput_=output_;
	}

}