/* 
* Pwm.cpp
*
* Created: 02/06/2015 22:53:45
* Author: Paul Soulsby
*/


#include "Pwm.h"

// default constructor
Pwm::Pwm(unsigned char waveLength)
{
	waveLength_ = waveLength;
	scale_ = 256 / waveLength;
} //Pwm

// default destructor
Pwm::~Pwm()
{
} //~Pwm

void Pwm::processWavetable(Wavetable& sourceWavetable, char envLevel, char lfoLevel)
{
	unsigned char i;
	unsigned char offset;
	if (lfoAmount_>0 || envAmount_>0)
	{
		unsigned char lfoOffset = ((unsigned int)lfoAmount_+1) * (lfoLevel + 127) >> 8;
		lfoOffset /= scale_;
		unsigned char envOffset = ((unsigned int)envAmount_+1) * abs(envLevel)  >> 7;
		envOffset /= scale_;
		if(lfoOffset+envOffset>waveLength_)
		{
			offset = waveLength_;
		}
		else
		{
			offset = lfoOffset + envOffset;
		}
		for(i=0;i<offset;++i)
		{
			sourceWavetable.setSample(i,0);
		}
	}	
}