/*
* RotaryEncoder.cpp
*
* Created: 09/06/2015 00:31:25
* Author: Paul Soulsby
*/


#include "RotaryEncoder.h"

// default constructor
RotaryEncoder::RotaryEncoder()
{
} //RotaryEncoder

// default destructor
RotaryEncoder::~RotaryEncoder()
{
} //~RotaryEncoder
void RotaryEncoder::setValue(char newValue)
{
	if(newValue>=maxValue_)
	{
		value_ = maxValue_-1;
	}
	else if(newValue<0)
	{
		value_ = 0;
	}
	else
	{
		value_ = newValue;
	}
}
void RotaryEncoder::setMaxValue(char newValue)
{
	maxValue_ = newValue;
	if(value_>=maxValue_)
	{
		value_ = maxValue_ - 1;
	}
}
bool RotaryEncoder::hasChanged(unsigned char ticksPassed)
{
	bool changed = false;
	
	int value_change = (count_-countLast_)/4;
	if(value_change!=0)
	{
		changed = true;
		countLast_ = count_;
		if(value_change>=0)
		{
			direction_ = true;
		}
		else
		{
			direction_ = false;
		}
		if(updateVal_==true)
		{
			value_ += value_change;
			if(continuous_==true)
			{
				if(value_>=maxValue_)
				{
					value_ -= maxValue_;
				}
				else if(value_<0)
				{
					value_ += maxValue_;
				}
			}
			else
			{
				if(value_>=maxValue_)
				{
					value_ = maxValue_-1;
				}
				else if(value_<0)
				{
					value_ = 0;
				}
			}
		}
	}
	return changed;
}