/*
* StepSequencer.cpp
*
* Created: 27/05/2015 17:17:20
* Author: Paul Soulsby
*/


#include "StepSequencer.h"

// default constructor
StepSequencer::StepSequencer(StepSequencerBase* base)
{
	base_ = base;
} //StepSequencer

// default destructor
StepSequencer::~StepSequencer()
{
	if(base_!=NULL)
	{
		delete base_;
	}
} //~StepSequencer

void StepSequencer::setPattern(unsigned char new_pattern)
{
	pattern_ = new_pattern;
	if(pattern_==0)
	{
		base_->stepseqNoteEvent(stepLast_,REST);
		stepLast_ = REST;
	}
}

void StepSequencer::setDivision(unsigned char newDiv)
{
	division_ = newDiv;
	divMult_ = pgm_read_word(&(seqMult[division_]));
	divBs_ = pgm_read_byte(&(seqBs[division_]));
}

void StepSequencer::reset()
{
	indexLast_ = seqLength;
	stepLast_ = REST;
}
void StepSequencer::refresh(unsigned int cycleTick)
{
	if(pattern_!=0)
	{
		unsigned char index = ((unsigned long)cycleTick * divMult_) >> divBs_;
		index &= seqBitMask;
		
		if(index!=indexLast_)
		{
			unsigned char step = pgm_read_byte(&(seqPatterns[pattern_][index]));
			base_->stepseqNoteEvent(stepLast_,step);
			stepLast_ = step;
			indexLast_ = index;
		}	
	}

}

