/* 
* StepSequencer.h
*
* Created: 27/05/2015 17:17:20
* Author: Paul Soulsby
*/


#ifndef __SS_STEPSEQUENCER_H__
#define __SS_STEPSEQUENCER_H__

#include <stdlib.h>
#include <string.h>
#include "StepSequencerProgmem.h"
#include "StepSequencerBase.h"

#ifndef bitRead
#define bitRead(value, bit) (((value) >> (bit)) & 0x01)
#endif
#ifndef bitSet
#define bitSet(value, bit) ((value) |= (1UL << (bit)))
#endif
#ifndef bitClear
#define bitClear(value, bit) ((value) &= ~(1UL << (bit)))
#endif
#ifndef bitWrite
#define bitWrite(value, bit, bitvalue) (bitvalue ? bitSet(value, bit) : bitClear(value, bit))
#endif


class StepSequencer
{
//variables
public:
	static const unsigned char REST = 128;
	static const unsigned char HOLD = 64;
protected:
private:
	StepSequencerBase* base_;
	unsigned char pattern_ = 0;
	unsigned char division_ = 2;
	unsigned int divMult_ = 1;
	unsigned char divBs_ = 8;
	unsigned char indexLast_ = 0;
	unsigned char stepLast_ = REST;
//functions
public:
	StepSequencer(StepSequencerBase* base);
	~StepSequencer();
	void setPattern(unsigned char new_pattern);
	unsigned char getPattern(){return pattern_;}
	void setDivision(unsigned char newDiv);
	unsigned char getDivision(){return division_;}
	void refresh(unsigned int cycleTick);
	void reset();
protected:
private:
	StepSequencer() {}
	StepSequencer( const StepSequencer &c );
	StepSequencer& operator=( const StepSequencer &c );
}; //StepSequencer

#endif //__SS_STEPSEQUENCER_H__
