/* 
* Switch.cpp
*
* Created: 08/06/2015 23:22:53
* Author: Paul Soulsby
*/


#include "Switch.h"

// default constructor
Switch::Switch(unsigned char initValue, unsigned int holdTicks)
{
	state_ = initValue;
	stateLast_ = initValue;
	holdEventTicks_ = holdTicks;
} //Switch

// default destructor
Switch::~Switch()
{
} //~Switch

bool Switch::hasHeld(unsigned char ticksPassed)
{
	bool held = false;
	if(state_==HIGH)
	{
		holdTime_ += ticksPassed;
		if(holdTime_>=holdEventTicks_ && holdEventFired_==false)
		{
			held = true;
			holdEventFired_ = true;
		}
		
	}	
	return held;
}
bool Switch::hasChanged(unsigned char ticksPassed)
{
	bool changed = false;

	if(ticks_<debounceTicks_)
	{
		ticks_ += ticksPassed;
	}
	if(ticks_>=debounceTicks_)
	{
		if(state_!=stateLast_)
		{
			if(state_==HIGH && stateLast_==LOW)
			{
				holdTime_ = 0;
				holdEventFired_ = false;
				changed = true;
			}
			else if(state_==LOW && stateLast_==HIGH)
			{
				changed = true;
			}
			stateLast_ = state_;
			ticks_ = 0;
		}
	}
	return changed;
}