/* 
* Switch.h
*
* Created: 08/06/2015 23:22:53
* Author: Paul Soulsby
*/


#ifndef __SWITCH_H__
#define __SWITCH_H__

#define HIGH 0x1
#define LOW  0x0

class Switch
{
//variables
public:
protected:
private:
	unsigned char state_ = LOW;
	unsigned char ticks_ = 0;
	unsigned char stateLast_ = LOW;
	unsigned int holdTime_ = 0;
	bool holdEventFired_ = false;
	unsigned char debounceTicks_ = 100;
	unsigned int holdEventTicks_ = 2000;
//functions
public:
	Switch() {}
	Switch(unsigned char initValue, unsigned int holdTicks);
	~Switch();
	void setState(unsigned char newState){state_ = newState;}
	unsigned char getState(){return state_;}
	unsigned int getHoldTime(){return holdTime_;}
	void setDebounceTicks(unsigned char newValue){debounceTicks_ = newValue;}
	bool hasChanged(unsigned char ticksPassed);
	bool hasHeld(unsigned char ticksPassed);
protected:
private:
	//Switch( const Switch &c );
	//Switch& operator=( const Switch &c );

}; //Switch

#endif //__SWITCH_H__
