/* 
* WaveCrusher.cpp
*
* Created: 30/05/2015 22:18:34
* Author: Paul Soulsby
*/


#include "WaveCrusher.h"

// default constructor
WaveCrusher::WaveCrusher()
{
} //WaveCrusher

// default destructor
WaveCrusher::~WaveCrusher()
{
} //~WaveCrusher

void WaveCrusher::setType(unsigned char newType)
{
	type_ = newType;
	if(type_==0)
	{
		sampleShift_ = 0;
		sampleHold_ = 1;	
	}
	else
	{
		sampleShift_ = (type_%4) + 4;
		sampleHold_ = 1 << (type_>>2);		
	}
}

void WaveCrusher::processWavetable(Wavetable& sourceWavetable)
{
	char samp;
	for (unsigned char i=0;i<sourceWavetable.getWaveLength();++i)
	{
		if (i % sampleHold_ == 0)
		{
			samp = sourceWavetable.getSample(i);
			samp = samp >> sampleShift_;
			samp = samp << sampleShift_;
		}
		sourceWavetable.setSample(i,samp);
	}	
}