/* 
* Wavetable.cpp
*
* Created: 05/05/2015 00:13:43
* Author: Paul Soulsby
*/


#include "Wavetable.h"

// default constructor
Wavetable::Wavetable() : samples_(NULL), waveLength_(0)
{
} //Wavetable

Wavetable::Wavetable(unsigned char waveLength)
{
	waveLength_ = waveLength;
	samples_ = new char[waveLength_];
}

Wavetable::Wavetable(const Wavetable& wt)
{
	waveLength_ = wt.waveLength_;
	samples_ = new char[wt.waveLength_];
	for(unsigned char i=0;i<waveLength_;++i)
	{
		samples_[i] = wt.samples_[i];
	}
}
// default destructor
Wavetable::~Wavetable()
{
	if(samples_ != NULL)
	{
		delete [] samples_;
	}
} //~Wavetable

Wavetable& Wavetable::operator = (const Wavetable& wt)
{
	if (&wt == this)
	{
		return *this;
	}
	if(samples_ != NULL)
	{
		delete [] samples_;
	}
	waveLength_ = wt.waveLength_;
	samples_ = new char[wt.waveLength_];
	for(unsigned char i=0;i<waveLength_;++i)
	{
		samples_[i] = wt.samples_[i];
	}
	return *this;
}

void Wavetable::clearSamples()
{
	memset(samples_,0,sizeof(*samples_));
}

bool Wavetable::isAllSamplesSame()
{
	for(unsigned char i=1;i<waveLength_;++i)
	{
		if(samples_[i]!=samples_[0])
		{
			return false;
		}
	}
	return true;
}